////////////////////////////////////////////////////////////////////////////////
// main.pas
// Jednoduchy zobrazovac vezi
// Soutez v programovani, Ustredni kolo, Janske Lazne 2014
// main executable file
// (c) Jan Horacek, soutezni cislo 22
// jan.horacek@seznam.cz
// 21.06.2014
// v1.0
// license: Apache license v2.0
////////////////////////////////////////////////////////////////////////////////

unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, StdCtrls;

type
  TKostka = record
    color:TColor;
    pos, size:TPoint;
  end;

  TPatro = record
    kostky: array [0..400] of TKostka;
    kostky_cnt: Word;
  end;

  TF_Main = class(TForm)
    OD_Open: TOpenDialog;
    B_Load: TButton;
    B_ShowPatro: TButton;
    Label1: TLabel;
    L_PatraCnt: TLabel;
    B_Rekap: TButton;
    procedure B_LoadClick(Sender: TObject);
    procedure B_ShowPatroClick(Sender: TObject);
    procedure B_RekapClick(Sender: TObject);
  private
    procedure Open(filename:string);
    procedure aReset();

  public
    patra: array of TPatro;
    patra_cnt:Word;

    vez_size:TPoint;

  end;

var
  F_Main: TF_Main;

implementation

uses patro, rekap;

{$R *.dfm}

// reset dat v pameti - vola se pred nactenim souboru
procedure TF_Main.aReset();
var i:Integer;
begin
 for i := 0 to Length(Self.patra)-1 do
  Self.patra[i].kostky_cnt := 0;

 Self.patra_cnt := 0;
end;//procedure

// otevreni souboru
procedure TF_Main.Open(filename:string);
var f:TextFile;
    line:string;
    data, rozmery:TStrings;
    patro:Word;
begin
 Self.aReset();

 try
  AssignFile(f, filename);
  Reset(f);
 except
  Application.MessageBox('Cannot load', 'Error', MB_OK OR MB_ICONERROR);
  Exit;
 end;

 data := TStringList.Create();
 rozmery := TStringList.Create();

 Readln(f, line);
 ExtractStrings([' '], [], PChar(line), data);

 // nacteme hlavicku
 Self.vez_size.X := StrToInt(data[0]);
 Self.vez_size.Y := StrToInt(data[1]);

 SetLength(Self.patra, 1024);

 // nacitame jednotliva patra a kostky v nich
 while (not Eof(f)) do
  begin
   Readln(f, line);
   data.Clear();
   ExtractStrings([' '], [], PChar(line), data);

   if (data.Count = 0) then continue;

   // dynamicky rozsirujeme pole
   patro := StrToInt(data[0]);
   if (patro > Length(Self.patra)) then
    SetLength(Self.patra, Length(Self.patra)+1024);

   // pridani noveho patra
   if (patro > Self.patra_cnt) then
    Self.patra_cnt := patro;

   // cteni paramtru kostky
   Self.patra[patro].kostky_cnt := Self.patra[patro].kostky_cnt + 1;
   Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].pos.X := StrToInt(data[1]);
   Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].pos.Y := StrToInt(data[2]);

   // cteni barvy
   case (data[3][1]) of
    'A': Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].color := RGB(0, 255, 255);
    'R': Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].color := RGB(255, 0, 0);
    'G': Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].color := RGB(0, 255, 0);
    'B': Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].color := RGB(0, 0, 255);
    'Y': Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].color := RGB(255, 255, 0);
   end;

   rozmery.Clear();
   ExtractStrings(['x', 'X'], [], PChar(data[4]), rozmery);

   Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].size.X := StrToInt(rozmery[0]);
   Self.patra[patro].kostky[Self.patra[patro].kostky_cnt-1].size.Y := StrToInt(rozmery[1]);
  end;//while

 CloseFile(f);
 data.Free();
 rozmery.Free();
end;//procedure

// klik na tlacitko "Nacist soubor"
procedure TF_Main.B_LoadClick(Sender: TObject);
begin
 F_Patro.Close();

 if (Self.OD_Open.Execute(Self.Handle)) then
  begin
   Self.Open(Self.OD_Open.FileName);
   Self.L_PatraCnt.Caption := IntToStr(Self.patra_cnt);

   Self.B_ShowPatro.Enabled := true;
   Self.B_Rekap.Enabled     := true;
  end;
end;//procedure

// klik na tlacitko "Rekapitulace"
procedure TF_Main.B_RekapClick(Sender: TObject);
begin
 if (Self.patra_cnt > 0) then
   F_Rekap.Show();
end;

// klik na tlacitko "Zobrazit patro"
procedure TF_Main.B_ShowPatroClick(Sender: TObject);
begin
 if (Self.patra_cnt > 0) then
   F_Patro.Show();
end;

end.//unit

