////////////////////////////////////////////////////////////////////////////////
// patro.pas
// Jednoduchy zobrazovac vezi - vykresovani patra
// Soutez v programovani, Ustredni kolo, Janske Lazne 2014
// main executable file
// (c) Jan Horacek, soutezni cislo 22
// jan.horacek@seznam.cz
// 21.06.2014
// v1.0
// license: Apache license v2.0
////////////////////////////////////////////////////////////////////////////////

// k vykreslovani pouzivame DXdraw, ktery bezi na DirectX

unit patro;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, DXDraws;

const
  _KOSTKA_SIZE = 20;   // px

type
  TF_Patro = class(TForm)
    Label1: TLabel;
    SE_Patro: TSpinEdit;
    DXDraw1: TDXDraw;
    procedure SE_PatroChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ShowPatro(index:Integer);
  end;

var
  F_Patro: TF_Patro;

implementation

uses main;

{$R *.dfm}

// jednorazove vykreslime patro
procedure TF_Patro.ShowPatro(index:Integer);
var i:Integer;
    border:TPoint;
begin
 Border := Point(10, 10);

 try
   Self.DXDraw1.Surface.Canvas.Release();
   Self.DXDraw1.Surface.Fill(clWhite);

   Self.DXDraw1.Surface.Canvas.Pen.Color := clBlack;

   for i := 0 to F_Main.patra[index].kostky_cnt-1 do
    begin
     Self.DXDraw1.Surface.Canvas.Brush.Color := F_Main.patra[index].kostky[i].color;
     Self.DXDraw1.Surface.Canvas.Rectangle(
      (F_Main.patra[index].kostky[i].pos.X*_KOSTKA_SIZE) + Border.X,
      (F_Main.patra[index].kostky[i].pos.Y*_KOSTKA_SIZE) + Border.Y,
      ((F_Main.patra[index].kostky[i].pos.X + F_Main.patra[index].kostky[i].size.X)*_KOSTKA_SIZE) + Border.X,
      ((F_Main.patra[index].kostky[i].pos.Y + F_Main.patra[index].kostky[i].size.Y)*_KOSTKA_SIZE) + Border.Y
     );
    end;//for i

   Self.DXDraw1.Surface.Canvas.Release();
   Self.DXDraw1.Flip;
 except
   Exit();
 end;

end;//procedure

// pri vytvareni okynka vyplnime DXdraw bulou barvou
procedure TF_Patro.FormCreate(Sender: TObject);
begin
 Self.DXDraw1.Surface.Fill(clWhite);
 Self.DXDraw1.Initialize;
end;

// pri zobrazeni okna zobrazime patro 1
procedure TF_Patro.FormShow(Sender: TObject);
begin
 Self.SE_Patro.MinValue := 1;
 Self.SE_Patro.MaxValue := F_Main.patra_cnt;
 Self.SE_Patro.Value    := 1;

 Self.SE_PatroChange(self);
end;

// pri zmene patra ho zobrazime
procedure TF_Patro.SE_PatroChange(Sender: TObject);
begin
 try
   Self.ShowPatro(Self.SE_Patro.Value);
 except
   Exit;
 end;
end;

end.//unit
