////////////////////////////////////////////////////////////////////////////////
// main.pas
// Jednoduchy zobrazovac vezi - vykreslovani rekapitulace
// Soutez v programovani, Ustredni kolo, Janske Lazne 2014
// main executable file
// (c) Jan Horacek, soutezni cislo 22
// jan.horacek@seznam.cz
// 21.06.2014
// v1.0
// license: Apache license v2.0
////////////////////////////////////////////////////////////////////////////////

unit rekap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TF_Rekap = class(TForm)
    FB_Color: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    L_B: TLabel;
    L_Y: TLabel;
    L_G: TLabel;
    L_R: TLabel;
    L_A: TLabel;
    GB_Rozmery: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    L_1x2: TLabel;
    L_1x1: TLabel;
    L_1x3: TLabel;
    L_1x4: TLabel;
    L_2x2: TLabel;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ShowColors();
    procedure ShowRozmery();
  end;

var
  F_Rekap: TF_Rekap;

implementation

uses main;

{$R *.dfm}

// zobrazit rekapitulaci barev
procedure TF_Rekap.ShowColors();
var A, R, G, B, Y:Word;
    i, j:Integer;
begin
 A := 0;
 R := 0;
 G := 0;
 B := 0;
 Y := 0;

 for i := 1 to F_Main.patra_cnt do
  begin
   for j := 0 to F_Main.patra[i].kostky_cnt-1 do
    begin
     case (F_Main.patra[i].kostky[j].color) of
      $FFFF00: A := A + 1;
      $0000FF: R := R + 1;
      $00FF00: G := G + 1;
      $FF0000: B := B + 1;
      $00FFFF: Y := Y + 1;
     end;//case
    end;//for j
  end;//for i

 Self.L_A.Caption := IntToStr(A);
 Self.L_R.Caption := IntToStr(R);
 Self.L_G.Caption := IntToStr(G);
 Self.L_B.Caption := IntToStr(B);
 Self.L_Y.Caption := IntToStr(Y);
end;//procedure

// zobrazit rekapitulaci rozmeru
procedure TF_Rekap.ShowRozmery();
var r2x2, r1x4, r1x3, r1x2, r1x1:Word;
    i, j:Integer;
begin
 r2x2 := 0;
 r1x4 := 0;
 r1x3 := 0;
 r1x2 := 0;
 r1x1 := 0;

 for i := 1 to F_Main.patra_cnt do
  begin
   for j := 0 to F_Main.patra[i].kostky_cnt-1 do
    begin
     if ((F_Main.patra[i].kostky[j].size.X = 2) and (F_Main.patra[i].kostky[j].size.Y = 2)) then r2x2 := r2x2 + 1;
     if ((F_Main.patra[i].kostky[j].size.X = 1) and (F_Main.patra[i].kostky[j].size.Y = 4)) or
        ((F_Main.patra[i].kostky[j].size.X = 4) and (F_Main.patra[i].kostky[j].size.Y = 1)) then r1x4 := r1x4 + 1;
     if ((F_Main.patra[i].kostky[j].size.X = 1) and (F_Main.patra[i].kostky[j].size.Y = 3)) or
        ((F_Main.patra[i].kostky[j].size.X = 3) and (F_Main.patra[i].kostky[j].size.Y = 1)) then r1x3 := r1x3 + 1;
     if ((F_Main.patra[i].kostky[j].size.X = 1) and (F_Main.patra[i].kostky[j].size.Y = 2)) or
        ((F_Main.patra[i].kostky[j].size.X = 2) and (F_Main.patra[i].kostky[j].size.Y = 1)) then r1x2 := r1x2 + 1;
     if ((F_Main.patra[i].kostky[j].size.X = 1) and (F_Main.patra[i].kostky[j].size.Y = 1)) then r1x1 := r1x1 + 1;
    end;//for j
  end;//for i

 Self.L_2x2.Caption := IntToStr(r2x2);
 Self.L_1x4.Caption := IntToStr(r1x4);
 Self.L_1x3.Caption := IntToStr(r1x3);
 Self.L_1x2.Caption := IntToStr(r1x2);
 Self.L_1x1.Caption := IntToStr(r1x1);
end;//procedure

// pri zorbaznei okynka zobrazime rekapitulaci
procedure TF_Rekap.FormShow(Sender: TObject);
begin
 Self.ShowColors();
 Self.ShowRozmery();
end;

end.//unit
